%%This is a part of multi-layered random forest (MLRF) framework

%add small clusters to the bigger clusters

function clusters = rearangeSmallClusters(Y,clusters,cmat,options)

    if (size(Y,1) < size(Y,2))
        Y = Y';
    end
    
    if (size(clusters,1) < size(clusters,2))
        clusters = clusters';
    end
    
    goodClasses = find(sum(cmat,1)>0);

    for i=1:length(goodClasses)
        idx = find(cmat(:,goodClasses(i)) < options.mincpc & cmat(:,goodClasses(i))>0);
        
        [elemcount,midx] = max(cmat(:,goodClasses(i)));
        
%         if (ismember(midx,idx))
%            save('/home/kuznetso/tmp/rearangeSmallClustersData.mat','Y','clusters','cmat','options');%save data for analysis
%            warning(['maximum size cluster is about to be removed: ' num2str(elemcount)]); 
%            idx = setdiff(idx,midx);
%         end
        
        if (~isempty(idx))
            tomove = (ismember(clusters,idx) & Y==goodClasses(i));
            
            clusters(tomove) = midx;
        end
    end
end