%%This is a part of multi-layered random forest (MLRF) framework

%normalize features using std and mean

function [X,Xmean,Xstd,exclude] = normalize(X,options)

    Xstd = std(X,0,1);
    disp(['Number of components to exclude: ' num2str(sum(Xstd<options.stdThr))]);

    X(:,Xstd<options.stdThr) = [];
    exclude = (Xstd<options.stdThr);
    
    Xstd = std(X,0,1);
    Xmean = mean(X,1);
    X = (X - repmat(Xmean,size(X,1),1))./repmat(Xstd,size(X,1),1);

end